import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "igniteui-react-core/ES5/type";
import { IFastItemColumn$1 } from "igniteui-react-core/ES5/IFastItemColumn$1";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { Polyline } from "igniteui-react-core/ES5/Polyline";
import { Polygon } from "igniteui-react-core/ES5/Polygon";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { Axis } from "./Axis";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core/ES5/FastItemsSourceEventAction";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
}
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    static $t: Type;
    protected bf(): SeriesView;
    getHostReferenceValue(): number;
    il(a: SeriesView): void;
    oo: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    RangeFramePreparer: RangeCategoryFramePreparer;
    ox: string;
    lowColumn: IFastItemColumn$1<number>;
    private or;
    ou: string;
    highColumn: IFastItemColumn$1<number>;
    private op;
    protected m7(): CategoryTransitionInMode;
    of(a: CategoryFrame, b: CategorySeriesView): void;
    protected oz(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    c7(a: any): boolean;
    protected ir(a: any, b: string, c: any, d: any): void;
    an(a: Axis): AxisRange;
    protected hr(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    du(a: Rect, b: Rect, c: SeriesView): boolean;
    oc(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly mayContainUnknowns: boolean;
    i6(a: Rect, b: RenderSurface): void;
    private om;
    i3(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ed(): number;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
export declare class RangeCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    cw: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    cx(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    co(): CategoryBucketCalculator;
}
